function [h, f] = fb_cos_modulated_filters(p, M)  % Wspolczynniki $M$-kanalowego ...
                                           % zespolu filtrow z modulacja kosinusowa.

N = length(p);                                   % Dlugosc filtru prototypowego $p$.
[k, n] = ndgrid(0 : (M - 1), 0 : (N - 1));                  % Generacja indeksow ...
h = repmat(p, M, 1) .* 2 .* cos(pi/M .* (k + 0.5) ...    % i wspolczynnikow filtrow.
    .* (n - (N - 1)/2) + pi/4 * (-1) .^ k);
if (nargout > 1),  ...                                          % Filtry syntezy ...
        f = repmat(p, M, 1) .* 2 .* cos(pi/M .* (k + 0.5) .* ... % sa generowane ...
    (n - (N - 1)/2) - pi/4 * (-1) .^ k);                          % tylko wtedy, ...
end                                                               % kiedy potrzebne.