% Przyklad 6.2:
function przyklad_06_02()

N = 32;   M = 4;             % Dlugosc filtru i wspolczynnik decymacji/interpolacji.
f = 1 / M;                                  % Znormalizowana czestotliwosc odciecia.
delta = 1 / (2 * M);                 % Znormalizowana szerokosc pasma przejsciowego.
fp = f - delta;   fst = f;      % Czestotliwosci graniczne pasma przepustowego i ...
%fp = f - delta/2;  fst = f + delta/2; % zaporowego: dwie alternatywne specyfikacje.
d = fdesign.lowpass('n,fp,fst', N, fp, fst);       % Okreslenie specyfikacji filtru.
h = design(d, 'firls');       % Projektowanie filtru metoda najmniejszych kwadratow.
L = 128;        % Liczba wyznaczanych punktow segmentu charakterystyki amplitudowej.
[H, w] = freqz(h, 2 * L * M, 'whole');             % Wyznaczenie charakterystyki ...

figure;     hold on;                                            % i jej prezentacja.
for k = 1 : M,                             % Iteracja po segmentach charakterystyki.
    idx = (1 : (L + 1)) + (k - 1) * L;                   % Indeksy punktow segmentu.
    if (mod(k, 2) == 0),   idx = fliplr(idx);    end; % Co drugi segment "zawijamy".
    plot(w(1 : (L + 1)) / 2 / pi, 20 * log10(abs(H(idx)))); % Wyswietlenie segmentu.
end
box on;     grid on;    axis([0 0.5/M -100 10]);
xlabel('\Omega/2\pi');  ylabel('|H(e^{j\Omega}|) [dB]');

t = (0 : 127) / 128;                               % Generacja sygnalu testowego ...
x = sin(t * 2 * pi * 8) + sin(t * 2 * pi * 24);           % np. sumy dwoch sinusoid.
clc
if (strcmpi(input('Wybierz: D = decymacja, I = interpolacja.\n', 's'), 'D')),
    t = sprintf('Decymacja: M = %d, ', M);
    if (strcmpi(input(['Czy uzyc filtru do eliminacji nakladania widmowego? ' ...
            'T = tak, inny znak = nie.\n'], 's'), 'T')),
        v = filter(h, x); t = [t 'Z filtrem'];   else   v = x; t = [t 'Bez filtru'];
    end
    y = v(1 : M : end);
else
    t = sprintf('Interpolacja: M = %d, ', M);
    v = zeros(1, length(x) * M);    v(1 : M : end) = x;
    if (strcmpi(input(['Czy uzyc filtru do eliminacji replik widma? ' ...
            'T = tak, inny znak = nie.\n'], 's'), 'T')),
        y = filter(h, v); t = [t 'Z filtrem'];   else   y = v; t = [t 'Bez filtru'];
    end
end

figure                              % Prezentacja przebiegu zmiany tempa probkowana.
L = 128;    f = (0 : (L - 1)) / L;
subplot(3, 2, 1);   stem(x); ylabel('x[n]');   title(t);
subplot(3, 2, 2);   stem(f, abs(fft(x, L)));   ylabel('|X(e^{j\Omega})|');
subplot(3, 2, 3);   stem(v); ylabel('v[n]');
subplot(3, 2, 4);   stem(f, abs(fft(v, L)));   ylabel('|V(e^{j\Omega})|');
subplot(3, 2, 5);   stem(y); ylabel('y[n]');   xlabel('n');
subplot(3, 2, 6);   stem(f, abs(fft(y, L)));
ylabel('|Y(e^{j\Omega})|');   xlabel('\Omega/2\pi');