% Przyklad 6.9
function przyklad_06_09()

K = 5;                         % Liczba stopni w strukturze, a tym samym parametrow.
rand('state', sum(100 * clock));          % Inicjalizacja generatora liczb losowych.
a_start = rand(1, K) .* (2 * pi);              % Losowanie rozwiazania poczatkowego.

% Wielokrotne wywolanie algorytmu optymalizacyjnego z roznymi rozwiazaniami ...
% poczatkowymi zwieksza szanse na znalezienie globalnego optimum.

options = optimset('MaxFunEvals', 2000, 'DiffMinChange', 0.001, 'DiffMaxChange', ...
    0.5, 'TolFun', 1e-9, 'TolX', 1e-9);     % Parametry algorytmu optymalizacyjnego.
a_opt = fminunc(@obj_fun, a_start, options);         % Optymalizacja bez ograniczen.
obj_fun(a_opt); % Prezentacja znalezionego rozwiazania (zespolu filtrow) optymalnego

%===================================================================================
function err = obj_fun(a)      % Funkcja celu optymalizacji: generowanie i ocena ...
% odpowiedzi impulsowych filtrow okreslonych zadanym wektorem parametrow.

h = blkdiag(1, -1) ./ sqrt(2);                           % Stopien bazowy struktury.
for k = 1 : length(a)                    % Rozszerzenie struktury o kolejne stopnie.
    h = [cos(a(k)) sin(a(k)); -sin(a(k)) cos(a(k)) ] * h;                   % Obrot.
    if (k < length(a)),
        h = [h(1,:) 0 0; 0 0 h(2,:)]; % Opoznienie odpowiedzi impulsowej o 2 probki.
    end
end

% Ocena filtrow: na ile charakterystyka amplitudowa filtru LP ...
% w pasmie przepustowym odbiega od 1.

L = 512;                              % Liczba punktow charakterystyki amplitudowej.
H0 = fft(h(1, :), L);           % Obliczenie charakterystyki amplitudowej filtru LP.
err = sum((1 - abs(H0(1 : (L / 4 - 50)))) .^ 2);    % Miara jakosci charakterystyki.
if (nargout == 0),    % Jezeli funkcja wywolywana spoza algorytmu optymalizacji, ...
    fb_show_response(h, 512);               % to prezentacja charakterystyk filtrow.
end